package it.uniroma1.dis.jasmine;

import it.uniroma1.dis.jasmine.ui.utils.NumberField;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.math.BigDecimal;
import java.util.*;

import javax.swing.JTextArea;

import net.java.dev.eval.Expression;

public class FileSmvWriter{
	//private int j = 0;
	private int[] cammino;
	//conserva una HashTable con chiave String e valore NumberField[]
	private Hashtable<String,NumberField[]> hash = null;
	//conserva una HashTable con chiave String e valore JTextArea per conservare le pre e post condizioni
	private Hashtable<String,JTextArea> prePost = null;
	//variabile che indica se si sta facendo sideeffect o no
	private boolean sideEffect=false;
	//lista di variabili fittizie introdotte per risolvere il null problem
	private Vector<String> listaVar=new Vector();
	private HashSet<String> variabiliNull=new HashSet();
	
	/**
	 * @param nome
	 * @param w
	 * @param nodes
	 * @param hash
	 * @return
	 */
	//metodo che prende in ingresso il nome della classe java, il grafo w, l'insieme dei nodi del cammino
	//l'opzione su che tipo di cammino stiamo cercando , le tabelle hash e l'info se stiamo facendo side effect o meno
	public String generateNuSMV(String nome, Graph w, int[] nodes, int optCammino, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect) {
		if (hash!=null) this.hash=hash;
		if (prePost!=null) this.prePost=prePost;
		this.sideEffect=sideEffect;
		//i nodi del cammino da testare li inseriamo in cammino
		cammino = nodes;
		System.out.println("Nome metodo: "+w.getMethodName());
		System.out.println("Hash: "+w.getVariableHash());
		if (w.getVariableHash()!=null) {
			this.hash = w.getVariableHash();
			System.out.println("Qui, l'hash non  null");
		}
		else {
			System.out.println("Qui, l'hash  null");
			this.hash=null;
		}
		//ottieni la lista delle variabili che sono confrontate con null
		Vector<GraphNode> nodi=w.getNodes();
		for(GraphNode gn : nodi){
			if(gn.getCondition()!=null){
				String cond=gn.getCondition().getImage();
				if (cond != null) {
					if(cond.contains("!=null")){
						StringTokenizer stk=new StringTokenizer(cond,"!=");
						String nomeVar=stk.nextToken().trim();
						//se l'istruzione era del tipo !(var1!=null)
						//devo togliere i primi due caratteri per ottenere il nome della var corretto
						String p=""+nomeVar.charAt(0);
						if( p.equals("("))
							nomeVar=nomeVar.substring(1);
						variabiliNull.add(nomeVar.trim());
						System.out.println("la variabile " + nomeVar + "  confrontata con null");
					}else if(cond.contains("==null")){
						StringTokenizer stk=new StringTokenizer(cond,"==");
						String nomeVar=stk.nextToken().trim();
						//se l'istruzione era del tipo !(var1!=null)
						//devo togliere i primi due caratteri per ottenere il nome della var corretto
						String p=""+nomeVar.charAt(0);
						if( p.equals("("))
							nomeVar=nomeVar.substring(1);
						variabiliNull.add(nomeVar.trim());
						System.out.println("la variabile " + nomeVar + "  confrontata con null");
					}
				}
			}
			else if(gn.getExpression()!=null){
				String cond=gn.getExpression();
				if (cond != null) {
					if(cond.contains("null")){
						variabiliNull.add(gn.getVariable().trim());
						System.out.println("la variabile " + gn.getVariable() + "  assegnata a null");
					}
				}
			}
			System.out.println(".............." + gn.getCondition());
		}
		
		//StringBuilder  una implementazione pi efficiente di StringBuffer
		//a patto che sia usata su un singolo tread (non  sinchronized)
		StringBuilder sb = new StringBuilder();
		
		sb.append("MODULE"+" "+nome+"\n");
		sb.append(("--questo modulo descrive la funzione Java\n"));


		//===VAR===
		sb.append((this.editVARSection(w)));

		//===ASSIGN=== 
		sb.append((this.editASSIGNSection(w)));

		//===DEFINE===         
		sb.append(this.editDEFINESection(w));

		//===TRANS===
		sb.append(this.editTRANSSection(w));

		char ch=nome.charAt(0);
		String c = (""+ch).toLowerCase();

		sb.append("--end MODULE "+ nome +"\n\n");
		sb.append("MODULE main\n");
		sb.append("VAR\n");
		sb.append(" "+c+" : "+nome+";\n\n");
		sb.append("ASSIGN\n");

		sb.append(" init("+c+".PC):=1;\n");
		sb.append("--end MODULE main\n\n");
		sb.append("LTLSPEC\n");
		sb.append("--TERMINAZIONE\n");
		sb.append("--"+c+".PRE -> F("+c+".TERM);\n");
		sb.append("--CORRETTEZZA PARZIALE\n");
		sb.append("--"+c+".PRE -> G("+c+".TERM ->"+c+".POST);\n");
		sb.append("--CORRETTEZZA TOTALE\n");
		sb.append("--"+c+".PRE -> (F("+c+".TERM) & G("+c+".TERM ->"+c+".POST));\n");
		sb.append("--CAMMINO\n");
		
		if(nodes != null) {
			//cammino eventualmente scelto
			
			String spec = c+".PRE -> ";
			
			switch (optCammino) {
				//test di attraversamento da n_i a n_i+1
				case 1:
					int prev = -1;
					boolean first = true;
					int count = 0;
					while(count<cammino.length) {
						//System.out.println("found "+cammino[count]);
						if(!first)
							spec += " | ";
						if(prev<0)
							prev = cammino[count++];
						spec += "G("+c+".PC = "+prev+" -> X "+c+".PC != "+cammino[count]+")";
						first = false;
						prev = cammino[count];
						
						count++;
					}
					break;
				//cammino ordinato
				case 2:
					int count2 = 0;
					spec += "( ";
					//tutti i nodi sono visitati
					while(count2<cammino.length) {
						if(count2 == cammino.length-1)
							spec += "G !("+c+".PC = "+ cammino[count2]+") )";
						else
							spec += "G !("+c+".PC = "+ cammino[count2]+") | ";
							
						count2++;
					}
					//imponi l'ordinamento
					spec += " | (G !(";
					count2 = 0;
					
					
					Collection<Integer> array = new ArrayList<Integer>();
					
					while(count2<cammino.length-1) {
						
						if(array.contains(new Integer(cammino[count2+1]))) {
							count2++;
							continue;
						}
						if(count2 == cammino.length-2)
							spec += "("+ c+".PC != "+ cammino[count2+1]+" U "+c+".PC = "+ cammino[count2]+")";
						else
							spec += "("+ c+".PC != "+ cammino[count2+1]+" U "+c+".PC = "+ cammino[count2]+") & ";
						array.add(new Integer(cammino[count2]));
						count2++;
					}

					spec += "));";
					
					break;
				
				//cammino completo
				case 3:
					int count3 = 0;
					spec += "G !( ";
					while(count3<cammino.length) {
					
						if(count3 == cammino.length-1)
							spec += " "+c+".PC = "+ cammino[count3];
						else
							spec += " "+c+".PC = "+ cammino[count3]+ " & ";
						prev = cammino[count3];
						
						count3++;
						
						int x = 0;
					
						if(count3 < cammino.length)
							while(x < count3) {
								spec += "X ";
								x++;
							}
					}
					
					spec += ")";
				default:
					break;
			}
			
			
			
			
			
			if(spec.length()>0) {
				sb.append(("--CAMMINO\n"));
				sb.append(spec);
			}
		}
		return sb.toString();
	}
	
	/**
	 * @param nome
	 * @param w
	 * @param nodes
	 * @param hash
	 */
	public void writeFileNuSMV(String nome, Graph w, int[] nodes, int optCammino, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect){
		try{
			File f=new File("fileSMV");
			f.mkdir();

			File ff=new File(f, nome + ".smv");
			FileOutputStream fos=new FileOutputStream(ff,false);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			bos.write(generateNuSMV(nome, w, nodes, optCammino, hash, prePost, sideEffect).getBytes());
			
			bos.close();
			fos.close();
			
		} catch(Exception e) {
			System.out.println(" problemi con il file "+e.getMessage()+" "+ e.getCause());
			e.printStackTrace();
		}

	} 


/*
	private void editMainMODULE(String nome,FileOutputStream fos,Graph w){

		try{

			char ch=nome.charAt(0);
			String c = (""+ch).toLowerCase();
			fos.write(("MODULE main\n").getBytes());
			fos.write(("VAR\n").getBytes());
			fos.write((" "+c+" : "+nome+";\n\n").getBytes());
			fos.write(("ASSIGN\n").getBytes());

			fos.write((" init("+c+".PC):=1;\n").getBytes());
			Vector<Variabile> localVar = w.getVariableSet();
			for(int k=0; k<localVar.size(); k++){

				Variabile v=(Variabile)localVar.elementAt(k);
				fos.write((" init("+c+"."+v.getName()+"):=0;\n").getBytes());
				
			}
		
			
			fos.write(("--end MODULE main\n\n").getBytes());
			fos.write(("LTLSPEC\n").getBytes());
			fos.write(("--TERMINAZIONE\n").getBytes());
			fos.write(("--"+c+".PRE -> F("+c+".TERM);\n").getBytes());
			fos.write(("--CORRETTEZZA PARZIALE\n").getBytes());
			fos.write(("--"+c+".PRE -> G("+c+".TERM ->"+c+".POST);\n").getBytes());
			fos.write(("--CORRETTEZZA TOTALE\n").getBytes());
			fos.write(("--"+c+".PRE -> (F("+c+".TERM) & G("+c+".TERM ->"+c+".POST));\n").getBytes());
			fos.write(("--CAMMINO\n").getBytes());
			
			fos.write(("--").getBytes());
		}catch(Exception e){System.out.println(" problemi con il file "+e.getMessage()+" "+ e.getCause());}

	}
*/
	/**
	 * @param w
	 * @return
	 */
	private String editVARSection(Graph w){
		if (hash==null) {

		String result ="\nVAR\n";
		//il vactor var contiene le variabili in uso nel metodo (non i parametri, solo le variabili interne)
		Vector<Variabile> var=w.getVariableSet();
		int size=var.size();
		//scorri tutte le variabili e inseriscile nella sezione VAR con i corrispondenti valori
		//non viene fatto uno studio sul range di ogni variabile, i range sono prefissati
		for(int i=0; i<size; i++){
			Variabile v=(Variabile)var.elementAt(i);
			result +=" "+v.getName()+" :";
			if(v.isArray() && v.getTipo()=="int"){
				result +=" array"+" 0..2"+" of -10..10;\n";	
			}
			if(v.getTipo()=="int" && !v.isArray()){
				result +=" 0..3;"+"\n";

			}
		}
		//scorri tutte le istruzioni in cerca di una che
		//potrebbe causare il null problem 
		/*
		Vector<GraphNode> nodes=w.getNodes();
		for(int i=0;i<nodes.size();i++ ){
			String riga = "";
			GraphNode currNodo=(GraphNode)nodes.elementAt(i);
			riga += "   PC = "+ currNodo.getInitPC()+" ";
			if (currNodo.getCondition() != null) {
					String cond = currNodo.getCondition().getImage();
					cond = cond.replace("==", "=");
					if ((cond != null) && (cond.length() > 0)) {
						String s="!=null";
						 //se si pu presentare il null problem
						if(cond.contains(s)){
							//ricava il nome della variabile
							StringTokenizer stk=new StringTokenizer(cond,"!=");
							String nomeVar=stk.nextToken().trim();
							//se l'istruzione era del tipo !(var1!=null)
							//devo togliere i primi due caratteri per ottenere il nome della var corretto
							String p=""+nomeVar.charAt(0);
							if( p.equals("("))
								nomeVar=nomeVar.substring(1);
							//aggiungi una variabile fittizia per gestire il null problem
							//prima per controlla che non sia gi stata aggiunta
							Iterator it=listaVar.iterator();
							boolean nonCreare=false;
							while(it.hasNext()){
								if(((String)it.next()).equals(nomeVar.trim()))
									nonCreare=true;
							}
							if(!nonCreare){
								result +=" " + nomeVar + "null: 0..1;\n";
								listaVar.add(nomeVar.trim());
							}
						}
					}
			}
		} */
		for(String v : variabiliNull){
			result+=" " + v + "null: 0..1;\n";
		}
		//fine risoluzione del null problem
		
		//ottieni i parametri formali del metodo e inseriscili nella sezione VAR in NuSMV
		Vector<ParametroFormale> vct2=w.getParameterSet();
		int size2=vct2.size();
		for(int j=0; j<size2; j++){
			ParametroFormale pf=(ParametroFormale)vct2.elementAt(j);
			result +=" "+pf.nome+" :";
			if(pf.isArray && pf.tipo=="int"){
				result +=" array"+" 0..2"+" of -10..10;\n";	
			}
			if(pf.tipo=="int" && !pf.isArray){
				result +=" 0..3;"+"\n";

			}

		}

		result +=" PC : 1.."+w.getLoc()+";\n\n";
		return result;
		}
		
		
		
		
		else {    // se l'hash non  nullo
			String result ="\nVAR\n";

			Vector<Variabile> var=w.getVariableSet();
			int size=var.size();

			for(int i=0; i<size; i++){
				Variabile v=(Variabile)var.elementAt(i);
				result +=" "+v.getName()+" :";
				if(v.isArray() && v.getTipo()=="int"){
					result +=" array"+" 0.."+hash.get(v.getName()+".length")[0].getText()+" of "+hash.get(v.getName())[0].getText()+".."+hash.get(v.getName())[1].getText()+";\n";	
				}
				if(v.getTipo()=="int" && !v.isArray()){
					result +=hash.get(v.getName())[0].getText()+".."+hash.get(v.getName())[1].getText()+";\n";	

				}
			}
			//scorri tutte le istruzioni in cerca di una che
			//potrebbe causare il null problem
			/*
			Vector<GraphNode> nodes=w.getNodes();
			for(int i=0;i<nodes.size();i++ ){
				String riga = "";
				GraphNode currNodo=(GraphNode)nodes.elementAt(i);
				riga += "   PC = "+ currNodo.getInitPC()+" ";
				if (currNodo.getCondition() != null) {
						String cond = currNodo.getCondition().getImage();
						cond = cond.replace("==", "=");
						if ((cond != null) && (cond.length() > 0)) {
							String s="!=null";
							 //se si pu presentare il null problem
							if(cond.contains(s)){
								//ricava il nome della variabile
								StringTokenizer stk=new StringTokenizer(cond,"!=");
								String nomeVar=stk.nextToken().trim();
								//se l'istruzione era del tipo !(var1!=null)
								//devo togliere i primi due caratteri per ottenere il nome della var corretto
								String p=""+nomeVar.charAt(0);
								if( p.equals("("))
									nomeVar=nomeVar.substring(1);
								//aggiungi una variabile fittizia per gestire il null problem
								//prima per controlla che non sia gi stata aggiunta
								Iterator it=listaVar.iterator();
								boolean nonCreare=false;
								while(it.hasNext()){
									if(((String)it.next()).equals(nomeVar.trim()))
										nonCreare=true;
								}
								if(!nonCreare){
									result +=" " + nomeVar + "null: 0..1;\n";
									listaVar.add(nomeVar.trim());
								}
							}
						}
				}
			} */
			for(String v : variabiliNull){
				result+=" " + v + "null: 0..1;\n";
			}
			//fine risoluzione del null problem
			Vector<ParametroFormale> vct2=w.getParameterSet();
			int size2=vct2.size();
			for(int j=0; j<size2; j++){
				ParametroFormale pf=(ParametroFormale)vct2.elementAt(j);
				result +=" "+pf.nome+" :";
				if(pf.isArray && pf.tipo=="int"){
					result +=" array"+" 0.."+(Integer.parseInt(hash.get(pf.nome+".length")[0].getText())-1)+" of "+hash.get(pf.nome)[0].getText()+".."+hash.get(pf.nome)[1].getText()+";\n";	
					}
				if(pf.tipo=="int" && !pf.isArray){
					result +=hash.get(pf.nome)[0].getText()+".."+hash.get(pf.nome)[1].getText()+";\n";	
				}

			}

			result +=" PC : 1.."+w.getLoc()+";\n\n";
			return result;
		}

	}

	/**
	 * @param w
	 * @return
	 */
	private String editDEFINESection(Graph w){   

		String result="\nDEFINE\n";

		Vector<Integer> vct3=w.getNumTermIstr();
		int sizeRetArray = vct3.size();

		if(sizeRetArray==0)
			result+=" TERM := PC = "+w.getLoc()+";\n";

		else{
			String str="";
			for(int k=0;k<sizeRetArray;k++){
				Integer istr=(Integer)vct3.elementAt(k);
				int el=istr.intValue();
				if(k==sizeRetArray-1)
					str +="PC = "+el;
				else
					str +="PC = "+el+" | "; 
			}
			result+=" TERM := "+str+";\n";
		}
		
		if (w.getMethodCall()!=null) {
			if (w.getMethodCall().getPreCondition()==null) result+=" PRE := 1;\n";
			else result+=" PRE := "+w.getMethodCall().getPreCondition()+";\n";
			if (w.getMethodCall().getPostCondition()==null) result+=" POST := 1;\n";
			else result+=" POST := "+w.getMethodCall().getPostCondition()+";\n";
	
		}
		
		Vector<GraphNode> nodes=w.getNodes();
		for(int i=0;i<nodes.size();i++ ){
			GraphNode currNodo=(GraphNode)nodes.elementAt(i);
			
		if (currNodo.getMethodCall()!=null) {
			String pre = null;
			String post = null;
			
			for (int j = 0; j < currNodo.getMethodCall().getDeclaredParameters().size(); j++) {
				String dp = currNodo.getMethodCall().getDeclaredParameters().get(j);
				String pp = currNodo.getMethodCall().getPassedParameters().get(j);
				System.out.println("[[[+" + dp);
				System.out.println("[[[-" + pp);
				if (currNodo.getMethodCall().getPreCondition() != null) {
					pre = currNodo.getMethodCall().getPreCondition().replace(dp, pp);
					System.out.println("@@@" + currNodo.getMethodCall().getPreCondition() + " " + pre);
					result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := "+pre+";\n";
				}
				else {
					result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := 1;\n";
				}
				if (currNodo.getMethodCall().getPostCondition() != null) {
					post = currNodo.getMethodCall().getPostCondition().replace(dp, pp);
					System.out.println("@@@" + currNodo.getMethodCall().getPostCondition() + " " + post);
					result+=" "+currNodo.getMethodCall().getMethodName()+"POST := "+post+";\n";
					
				}
				else {
					result+=" "+currNodo.getMethodCall().getMethodName()+"POST := 1;\n";
				}
			}
			
			
		/*	System.out.println("Trovato un method call");
			System.out.println("Precondizioni: "+currNodo.getMethodCall().getPreCondition());
			System.out.println("Postcondizioni: "+currNodo.getMethodCall().getPostCondition());
			if (currNodo.getMethodCall().getPreCondition()==null) result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := 1;\n";
			else result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := "+currNodo.getMethodCall().getPreCondition()+";\n";
			if (currNodo.getMethodCall().getPostCondition()==null) result+=" "+currNodo.getMethodCall().getMethodName()+"POST := 1;\n";
			else result+=" "+currNodo.getMethodCall().getMethodName()+"POST := "+currNodo.getMethodCall().getPostCondition()+";\n";
		*/
		}
		}
			
		//per definire PRE, POST, TERm
/*		if (prePost==null) {
			result+=" PRE := 1;\n";
			result+=" POST := 1;\n\n";
		}
		else {
			String pre = prePost.get("pre").getText();
			if ((pre == null) || (pre.length() <= 0))
				pre = "1";
			String post = prePost.get("post").getText();
			if ((post == null) || (post.length() <= 0))
				post = "1";
			result+=" PRE := "+pre+";\n";
			result+=" POST := "+post+";\n\n";
		}*/
		result+="\n";
		return result;
	}

	/**
	 * @param w
	 * @return
	 */
	private String editASSIGNSection(Graph w){   

		String result = "ASSIGN\n";
		Vector<ParametroFormale> vct2=w.getParameterSet();
		
		//codifica il fatto che i valori delle variabili fittizie non sono modificabili introdotta per
		//il null problem. commentata il giorno 02/12/2008 e spalmata nella sezione TRANS
		/*Iterator it=listaVar.iterator();
		while(it.hasNext()){
			String s=(String)it.next();
			result+="next(" + s+"null):="+s+"null;\n";
		} */
		//fine modifica per il null problem
		
		//int size2=vct2.size();
/*		if (hash==null) {
		for(int k=0; k<size2; k++){

			ParametroFormale pf=(ParametroFormale)vct2.elementAt(k);
			if(pf.isArray && !sideEffect){
			for(int i=0; i<=2;i++){
					result+=" next("+pf.nome+"[" +i+ "]"+") := "+pf.nome+"[" +i+ "] ;\n";
				}
			}

		}
		}
		
		else {
			for(int k=0; k<size2; k++){

				ParametroFormale pf=(ParametroFormale)vct2.elementAt(k);
				if(pf.isArray && !sideEffect){
					for(int i=0; i<Integer.parseInt(hash.get(pf.nome+".length")[0].getText());i++){
						result+=" next("+pf.nome+"[" +i+ "]"+") := "+pf.nome+"[" +i+ "] ;\n";
					}
				}

			}	
		}*/
		
	
		return result;
	}  

	
	
	
	/*else {
		if (hash==null) {
			if(currPar.isArray){
			for(int q=0; q<=2;q++){
					result+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
				}
			}

		}
					
		else {
			if(currPar.isArray){
					for(int q=0; i<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
						result+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
					}
				}

			}	
		}*/
	
	
	/**
	 * @param w
	 * @return
	 */
	private String editTRANSSection(Graph w){

		String result="TRANS\n case\n";
		Vector<GraphNode> nodes=w.getNodes();
		Vector<Variabile> localVar = w.getVariableSet();
		Vector<ParametroFormale> formalParameters = w.getParameterSet();

		for(int i=0;i<nodes.size();i++ ){
			String riga = "";
			
			GraphNode currNodo=(GraphNode)nodes.elementAt(i);
			riga += "   PC = "+ currNodo.getInitPC()+" ";
			
					
if (currNodo.getCondition() != null) {
				
				String cond = currNodo.getCondition().getImage();
				cond = cond.replace("==", "=");
				cond=cond.replace("||", "|");
				//MODIFICA DEL 14/10/08 PER IL NULL PROBLEM NELLA SEZIONE TRANS
				if ((cond != null) && (cond.length() > 0)) {
					 //se si pu presentare il null problem
					if(cond.contains("!=null")){
						//ricava il nome della variabile
						StringTokenizer stk=new StringTokenizer(cond,"!=");
						String nomeVar=stk.nextToken().trim();
						//se l'istruzione era del tipo !(var1!=null)
						//devo togliere i primi due caratteri per ottenere il nome della var corretto
						String p=""+nomeVar.charAt(0);
						if( p.equals("("))
							nomeVar=nomeVar.substring(1);
						String rigaDaSostituire=cond.replace(nomeVar+"!=null", nomeVar + "null!=1");
						riga+="& "+ rigaDaSostituire + " ";
					}else if(cond.contains("==null")){
						StringTokenizer stk=new StringTokenizer(cond,"==");
						String nomeVar=stk.nextToken().trim();
						//se l'istruzione era del tipo !(var1==null)
						//devo togliere i primi due caratteri per ottenere il nome della var corretto
						String p=""+nomeVar.charAt(0);
						if( p.equals("("))
							nomeVar=nomeVar.substring(1);
						String rigaDaSostituire=cond.replace(nomeVar+"=null", nomeVar + "null=1");
						riga+="& "+ rigaDaSostituire + " ";
					}
					else
					riga+="& "+cond+ " ";
				}
			}

			riga +=": ";
			int destPC=currNodo.getDestPC();
			riga +="next(PC) = "+ destPC + " ";
			
			//modifica del 06/02/09 per tenere conto del nullproblem e
			//dei commenti della revisione
			
			//se ad una variabile che compare tra l'elenco di quelle confrontate con null
			//e gli viene assegnato un valore null allora imposto la sua varNull a 0
			//se  un'espressione
			
			//nonostante abbiamo che in una riga si ha next(anull):=1 comunque
			//dobbiamo imporre che per ogni var null next(varNull):=varNull
			
			if(currNodo.getVariable()!=null){
				//insieme v che contiene le variabili null per le quali abbiamo impostato il next
				HashSet<String> v=new HashSet();
				//estrai il contenuto della espressione prima dell' =
				StringTokenizer stk=new StringTokenizer(currNodo.getExpression(),"=");
				String primaDellUguale=currNodo.getVariable();
				String dopoLUguale=stk.nextToken();  //il primo token  vuoto
				if(dopoLUguale.trim().equals(""))
					dopoLUguale=stk.nextToken();
				//se a sin dell'uguale compare una variabile confrontata in null
				if(variabiliNull.contains(primaDellUguale.trim())){
					//se a destra compare null
					if(dopoLUguale.contains("null")){
						//allora next(varNull):=1
						riga+="& next(" + primaDellUguale.trim()+"null)=1 ";
						v.add(primaDellUguale.trim());
					}
					else{
						//controlla se a destra dell'uguale compare o no una variabileNull
						boolean contieneVar=false;
						for(String s : variabiliNull){
							if(dopoLUguale.contains(s)){
								contieneVar=true;
							}
						}
						//se a destra dell'uguale compare un valore che non  una variabile
						if(!contieneVar){
							//allora next(varNull):=0
							riga+="& next(" + primaDellUguale.trim()+"null)=0 ";
							v.add(primaDellUguale.trim());
						}
						//se a destra dell'uguale compare una variabile
						else{
							//allora next(varNull):=aNull
							riga+="& next(" + primaDellUguale.trim()+"null)=" + dopoLUguale.trim() + "null ";
							v.add(primaDellUguale.trim());
						}
					}
					//aggiungi i next per le variabili null non impostate
					for(String str : variabiliNull){
						if(!v.contains(str)){
							riga+="& next(" + str + "null)=" + str + "null ";
						}
					}
				}//altrimenti dobbiamo dire che ogni variabile varNull non pu cambiare
				else{
					for(String s : variabiliNull){
						riga+="& next(" + s + "null)=" + s + "null ";
					}
				}
			} else
			//dobbiamo dire che non pu cambiare anche per una condizione e non solo
			//per una assegnazione come abbiamo fatto prima
			//if(currNodo.getCondition()!=null){
			{
				for(String s : variabiliNull){
					riga+="& next(" + s + "null)=" + s + "null ";
				}
			}
			//---------fine modifica del 06/02/09
			
			//aggiunto il 02/12/2008 per spalmare le condizioni per il null problem
			//se il nodo corrente non  un nodo finale
			//if(currNodo.getInitPC()!=currNodo.getDestPC()){
				Iterator it=listaVar.iterator();
				while(it.hasNext()){
					String s=(String)it.next();
					riga+="& next(" + s+"null):="+s+"null ";
				}
			//}
			//fine aggiunta del 02/12/2008

			String expr= currNodo.getExpression();



			if(expr==null || expr.replace(" ", "").equals("") ){

				for(int j=0;j<localVar.size();j++){

					Variabile currVar=(Variabile)localVar.elementAt(j);
					String nomeVar=currVar.getName();
					riga += "& next("+nomeVar + ") = " +nomeVar+" "; 


				}
				for(int k=0;k<formalParameters.size();k++){

					ParametroFormale currPar=(ParametroFormale)formalParameters.elementAt(k);
					if(!currPar.isArray){
						String nomePar=currPar.nome;
						riga += "& next("+nomePar + ") = " +nomePar+" "; 
					}
					else {
						if (hash==null) {
							for(int q=0; q<=2;q++){
								riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
								}
						}
									
						else {
						for(int q=0; q<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
								riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
									}


							}	
						}

				}
			} 	
			else{

				//facciamo substring eliminando il primo carattere che e' uno spazio;
				String updateVar= currNodo.getVariable();
				//Spesso all'inizio ci sono aggiunti degli spazi in updateVar, e quindi dobbiamo verificare se ce ne sono, ed eliminarli
				int startRealString=0;
				char c=updateVar.charAt(startRealString);
				while(c==' '){
					startRealString=startRealString + 1;
					c=updateVar.charAt(startRealString);
				}  
				//eliminiamo gli spazi bianchi da updateVar 
				updateVar=updateVar.substring(startRealString);

				//	System.out.println("L'updateVar e' : "+updateVar+"\n");
				for(int j=0;j<localVar.size();j++){
					Variabile currVar=(Variabile)localVar.elementAt(j);
					String nomeVar=currVar.getName();

					//	System.out.println("Il nomeVar e': "+nomeVar+"\n");
					if(!nomeVar.equals(updateVar)){
						riga += "& next("+nomeVar + ") = " +nomeVar+" "; 
					}
					else{


						//dobbiamo considerare il primo carattere significativo(cioe' diverso da ' ')
						//e controllare se sia un '='
						int firstCharOffset=0;
						char firstChar=expr.charAt(firstCharOffset);
						boolean soloSpaziVuoti=false;
						while(firstChar==' '&& !soloSpaziVuoti){
							firstCharOffset=firstCharOffset+1;
							//NOTA:NON ELIMINARE QUESTO CONTROLLO: e' NECESSARIO POICHe' SI SONO VERIFICATI DEI CASI
							// DI ECCEZIONE DOVUTI A CASI DI STRINGHE expr costituite da soli SPAZI VUOTi ' '
							if(firstCharOffset<expr.length()){
								firstChar=expr.charAt(firstCharOffset);
							}
							else soloSpaziVuoti=true;
						}
						if(firstChar != '='){
							//modifica del 08/02/09 per togliere le assegnazioni a null
							if(!expr.contains("null"))
								riga += "& next("+nomeVar + ") = " +expr+" "; 
							//fine modifica
						}
						else{
							//modifica del 08/02/09 per togliere le assegnazioni a null
							if(!expr.contains("null"))
								riga += "& next("+nomeVar + ") " +expr+" ";
							//fine modifica
						}	
					}

				}

				for(int k=0;k<formalParameters.size();k++){
					ParametroFormale currPar=(ParametroFormale)formalParameters.elementAt(k);
					String nomePar=currPar.nome;
					System.out.println("\n\n\n\n\n\n\nupdateVar: "+updateVar);
					if(!currPar.isArray){

	
						//	System.out.println("Il nomeVar e': "+nomeVar+"\n");
						if(!nomePar.equals(updateVar)){
							riga += "& next("+nomePar + ") = " +nomePar+" "; 
						}
						else{
							//dobbiamo considerare il primo carattere significativo(cioe' diverso da ' ')
							//e controllare se sia un '='
							int firstCharOffset=0;
							char firstChar=expr.charAt(firstCharOffset);
							while(firstChar==' '){
								firstCharOffset=firstCharOffset+1;
								firstChar=expr.charAt(firstCharOffset);
							}
							if(firstChar != '='){
								riga += "& next("+nomePar + ") = " +expr+" "; 
							}
							else{
								riga += "& next("+nomePar + ") " +expr+" ";
							}	
						}
					} 
					else {
						if (hash==null) {
							for(int q=0; q<=2;q++){
								if(!(currPar.nome+"[" +q+ "]").equals(updateVar)) riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
								else riga+="& next("+currPar.nome+"[" +q+ "]"+") "+expr+" ";
								}
						}
									
						else {
						for(int q=0; q<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
							if(!(currPar.nome+"[" +q+ "]").equals(updateVar)) riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
							else riga+="& next("+currPar.nome+"[" +q+ "]"+") "+expr+" ";
							}


							}	
						}


				}

			}
			riga+= ";\n" ;
			riga = repairVectors(w,riga);
			riga= evaluateExpressions(riga);
			if (currNodo.getMethodCall()!=null) {
				riga=riga.replace(riga.substring(riga.indexOf(currNodo.getMethodCall().getMethodName()), (riga.indexOf(currNodo.getMethodCall().getMethodName())+riga.substring(riga.indexOf(currNodo.getMethodCall().getMethodName())).indexOf(")")+1)), currNodo.getMethodCall().getMethodName()+"POST");
				riga=riga.replace(":","& "+currNodo.getMethodCall().getMethodName()+"PRE :");
				
			}
		//	if (j>0 ) i--;
			result+=riga;
		}
		String def="   1: next(PC)=PC ";
		for(int k=0;k<formalParameters.size();k++){

			ParametroFormale currPar=(ParametroFormale)formalParameters.elementAt(k);
			//dobbiamo stampare nella sezione TRANS solo i parametri formali di tipo intero, e non quelli di tipo array
			//che li abbiamo resi tutti statici nella sezione ASSIGN
			if(!currPar.isArray){
				String nomePar=currPar.nome;
				def += "& next("+nomePar + ") = " +nomePar+" "; 
			}
			else {
				if (hash==null) {
					for(int q=0; q<=2;q++){
							def+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
						}
				}
							
				else {
							for(int q=0; q<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
								def+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
							}
					}	
				}
		}
		for(int j=0;j<localVar.size();j++){
			Variabile currVar=(Variabile)localVar.elementAt(j);
			String nomeVar=currVar.getName();

			//	System.out.println("Il nomeVar e': "+nomeVar+"\n");
				def += "& next("+nomeVar + ") = " +nomeVar+" "; 
		}

				result+=def;

		result+=";\nesac\n";
		result=checkBounds(result);
		
		

		return result;
	}
	
	
	
	
	public String repairVectors(Graph w,String riga) {

		//correttore lunghezze array
		if (riga.indexOf(".length")>-1)  {
			if (hash==null) {	
				StringTokenizer st = new StringTokenizer(riga,"!<>=|()+-*/ ");
				while (st.hasMoreTokens()) {
					String key = st.nextToken();
					if (key.indexOf(".length")>-1)  
						riga = riga.replace(key, "3");
				}
			}
			else {
				StringTokenizer st = new StringTokenizer(riga,"!<>=|()+-*/ ");
				while (st.hasMoreTokens()) {
					String key = st.nextToken();
					if (key.indexOf(".length")>-1) { 
						StringTokenizer st3 = new StringTokenizer(key,".");
						String tokenizer = st3.nextToken();
						riga = riga.replace(key, hash.get(tokenizer+".length")[0].getText());
					}
				}
			}
		}

		
		
		//raccolgo il contenuto degli indici degli array
		String riga2 = riga;
		List<String> list = new LinkedList<String>();
		while (riga2.indexOf("[")>-1) { 
			list.add(riga2.substring(riga2.indexOf("["),riga2.indexOf("]")+1));
			riga2=riga2.substring(riga2.indexOf("]")+1);
		}

		Vector<Variabile> localVar = w.getVariableSet();

		String lastVariabileScandita="";
		for (Variabile v:localVar) {
			for (int i = 0;i<list.size();i++)  {
				System.out.println("v "+v.getName()+";");
				System.out.println("Espressione in array "+i+": "+list.get(i));

				//cerco se la variabile e' presente negli indici degli array
			//	if (!v.getName().equals(lastVariabileScandita) && list.get(i).indexOf(v.getName())>-1) {
				if (list.get(i).indexOf(v.getName())>-1) {
						if (list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("+") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("-")  || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("*") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("/") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals(" ") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("["))
						if (list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("+") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("-")  || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("*") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("/") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals(" ") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("]")) {
							
							//variabile trovata negli indici degli array
							String originalRiga=riga;
							String originalRiga2="";
							riga="";
							if (hash==null) {
								if (!lastVariabileScandita.equals(v.getName())) {
								for (int k=0;k<=2;k++) {
									
										lastVariabileScandita=v.getName();
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									//	System.out.println("original riga 2: "+originalRiga2);
										//	riga+=repairVectors(w,originalRiga2.replace(":", "& "+v.getName()+"="+k+" :"));
										riga+=originalRiga2.replace(":", "& "+v.getName()+"="+k+" :");
									}
								}
								/*	else { //gi scandita in precedenza
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+0));
										//System.out.println("Original riga2: "+originalRiga2);
										riga+=originalRiga2;
										}*/
								else { //gi scandita in precedenza
									StringTokenizer st = new StringTokenizer(originalRiga,";");
								
									for (int k=0;k<=2 && st.hasMoreTokens();k++) {
										originalRiga2+=st.nextToken().replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									    originalRiga2+=";";
									}
									System.out.println("Original riga2: \n"+originalRiga2);
									riga+=originalRiga2+"\n";
									System.out.println("Riga: \n"+riga);
									
									}
								}
							
							
							else {  //hash diverso da null
								if (!lastVariabileScandita.equals(v.getName())) {
								for (int k=0;k<=Integer.parseInt(hash.get(v.getName())[1].getText())-1;k++) {
									
										lastVariabileScandita=v.getName();
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									//	System.out.println("original riga 2: "+originalRiga2);
										//	riga+=repairVectors(w,originalRiga2.replace(":", "& "+v.getName()+"="+k+" :"));
										riga+=originalRiga2.replace(":", "& "+v.getName()+"="+k+" :");
									}
								}
								/*	else { //gi scandita in precedenza
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+0));
										//System.out.println("Original riga2: "+originalRiga2);
										riga+=originalRiga2;
										}*/
								else { //gi scandita in precedenza
									StringTokenizer st = new StringTokenizer(originalRiga,";");
								
									for (int k=0;k<Integer.parseInt(hash.get(v.getName())[1].getText()) && st.hasMoreTokens();k++) {
										originalRiga2+=st.nextToken().replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									    originalRiga2+=";";
									}
									System.out.println("Original riga2: \n"+originalRiga2);
									riga+=originalRiga2+"\n";
									System.out.println("Riga: \n"+riga);
									
									}
								}
							
							
						}
				}
			}
	}
		
		
		return riga;
	}
	
	
	
	public String evaluateExpressions(String riga) {
		//raccolgo il contenuto degli indici degli array
		String riga2 = riga;
		List<String> list = new LinkedList<String>();
		while (riga2.indexOf("[")>-1) { 
			list.add(riga2.substring(riga2.indexOf("["),riga2.indexOf("]")+1));
			riga2=riga2.substring(riga2.indexOf("]")+1);
		}
		for (int i=0;i<list.size();i++) {
			System.out.println("Espressione: "+list.get(i));
			Expression exp = new Expression(list.get(i).substring(1, list.get(i).length()-1));
			 BigDecimal result = exp.eval();
			 System.out.println("Valutazione: "+result);
			 riga=riga.replace(list.get(i), "["+result+"]");
		}
		
		return riga;
	}
	
	
	
	
	public String checkBounds(String result) {
		StringTokenizer numRighe = new StringTokenizer(result,";");
		String riga="";
		while (numRighe.hasMoreTokens()) {
			riga=numRighe.nextToken();
			
			
			if (hash==null) {
			    if (riga.indexOf("[3]")>-1) result=result.replace(riga+";", "");
				if (riga.indexOf("[-1]")>-1) result=result.replace(riga+";", "");
			}
			
			
			else { //hash e' diverso da null
				StringTokenizer st = new StringTokenizer(riga,"!<>=|()+-*/ ");
				while (st.hasMoreTokens()) {
					String key = st.nextToken();
					if (key.indexOf("[")>-1) {  //sistemo indici vettori
						StringTokenizer st2 = new StringTokenizer(key,"[]");
						String vector = "";
						String position = "";
						if (st2.hasMoreTokens())vector = st2.nextToken();
						if (st2.hasMoreTokens())position = st2.nextToken();

						try {
							int indice = Integer.parseInt(position); //controllo se si tratta di un numero tra le parentesi quadre
							if (indice>=Integer.parseInt(hash.get(vector+".length")[0].getText())) result=result.replace(riga+";", "");
							if (riga.indexOf("[-1]")>-1) result=result.replace(riga+";", "");
						
						}
						catch (Exception ex) {  //non e' un numero
							System.out.println("Errore : eccezione in check bounds!");
						}
					}
				}
			}
		}
	
		
		return result;
	}
	
	
}
