package it.uniroma1.dis.jasmine;

import it.uniroma1.dis.jasmine.ui.utils.NumberField;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.JTextArea;

import net.java.dev.eval.Expression;

public class FileSmvWriterBaseprimaDelNullProblem{
	//private int j = 0;
	private int lunghezzaBase=3;
	private int[] cammino;
	private Hashtable<String,NumberField[]> hash = null;
	private Hashtable<String,JTextArea> prePost = null;
	private boolean sideEffect=false;
	/**
	 * @param nome
	 * @param w
	 * @param nodes
	 * @param hash
	 * @return
	 */
	public String generateNuSMV(String nome, Graph w, int[] nodes, int lenBase, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect) {
		if (hash!=null) this.hash=hash;
		if (prePost!=null) this.prePost=prePost;
		this.sideEffect=sideEffect;
		//cammino = nodes;
		lunghezzaBase=lenBase;
		System.out.println("Nome metodo: "+w.getMethodName());
		System.out.println("Hash: "+w.getVariableHash());
		if (w.getVariableHash()!=null) {
			this.hash = w.getVariableHash();
			System.out.println("Qui, l'hash non  null");
		}
		else {
			System.out.println("Qui, l'hash  null");
			this.hash=null;
		}
				
		StringBuilder sb = new StringBuilder();
		
		sb.append("MODULE"+" "+nome+"\n");
		sb.append(("--questo modulo descrive la funzione Java\n"));


		//===VAR===
		sb.append((this.editVARSection(w)));

		//===ASSIGN=== 
		sb.append((this.editASSIGNSection(w)));

		//===DEFINE===         
		sb.append(this.editDEFINESection(w));

		//===TRANS===
		sb.append(this.editTRANSSection(w));

		char ch=nome.charAt(0);
		String c = (""+ch).toLowerCase();

		sb.append("--end MODULE "+ nome +"\n\n");
		sb.append("MODULE main\n");
		sb.append("VAR\n");
		sb.append(" "+c+" : "+nome+";\n\n");
		sb.append("ASSIGN\n");

		sb.append(" init("+c+".PC):=1;\n");
		sb.append("--end MODULE main\n\n");
		sb.append("LTLSPEC\n");
		sb.append("--TERMINAZIONE\n");
		sb.append("--"+c+".PRE -> F("+c+".TERM);\n");
		sb.append("--CORRETTEZZA PARZIALE\n");
		sb.append("--"+c+".PRE -> G("+c+".TERM ->"+c+".POST);\n");
		sb.append("--CORRETTEZZA TOTALE\n");
		sb.append("--"+c+".PRE -> (F("+c+".TERM) & G("+c+".TERM ->"+c+".POST));\n");
		sb.append("--CAMMINO\n");
		
		
		//*******************************************************
		//creazione dei vincoli di indipendenza dei cammini
		//*******************************************************
		Vector<GraphNode> gn=w.getNodes();
			//cerco il valore max del PC
			int maxPC=gn.elementAt(0).getInitPC();
			for(int k=1;k<gn.size();k++){
				if(gn.elementAt(k).getInitPC()>maxPC)
					maxPC=gn.elementAt(k).getInitPC();
			}
			// adesso maxPC corrisponde al valore del PC dell'ultimo nodo
			// creo la clausola
			String indipCam="!(";
			for(int camm=1; camm<lunghezzaBase;camm++){
				if(camm==1)
					indipCam+="((";
				else
					indipCam+=" & ((";
				for(int nod=1;nod<=maxPC;nod++){
					indipCam+="F("+ c + ".cammino=" + camm + " & "+ c + ".PC=" + nod +")";
					for(int prossCamm=camm+1;prossCamm<=lunghezzaBase;prossCamm++){
						indipCam+=" & !F("+ c + ".cammino=" + prossCamm + " & "+ c + ".PC=" + nod +")";
					}
					indipCam+=")";
					if(nod!=maxPC)
						 indipCam+=" | (";
				}
				indipCam+=")";
			}
			
			sb.append(indipCam + ")\n");
		
		return sb.toString();
	}
	
	/**
	 * @param nome
	 * @param w
	 * @param nodes
	 * @param hash
	 */
	public void writeFileNuSMV(String nome, Graph w, int[] nodes, int optCammino, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect){
		try{
			File f=new File("fileSMV");
			f.mkdir();

			File ff=new File(f, nome + ".smv");
			FileOutputStream fos=new FileOutputStream(ff,false);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			bos.write(generateNuSMV(nome, w, nodes, optCammino, hash, prePost, sideEffect).getBytes());
			
			bos.close();
			fos.close();
			
		} catch(Exception e) {
			System.out.println(" problemi con il file "+e.getMessage()+" "+ e.getCause());
			e.printStackTrace();
		}

	} 


/*
	private void editMainMODULE(String nome,FileOutputStream fos,Graph w){

		try{

			char ch=nome.charAt(0);
			String c = (""+ch).toLowerCase();
			fos.write(("MODULE main\n").getBytes());
			fos.write(("VAR\n").getBytes());
			fos.write((" "+c+" : "+nome+";\n\n").getBytes());
			fos.write(("ASSIGN\n").getBytes());

			fos.write((" init("+c+".PC):=1;\n").getBytes());
			Vector<Variabile> localVar = w.getVariableSet();
			for(int k=0; k<localVar.size(); k++){

				Variabile v=(Variabile)localVar.elementAt(k);
				fos.write((" init("+c+"."+v.getName()+"):=0;\n").getBytes());
				
			}
		
			
			fos.write(("--end MODULE main\n\n").getBytes());
			fos.write(("LTLSPEC\n").getBytes());
			fos.write(("--TERMINAZIONE\n").getBytes());
			fos.write(("--"+c+".PRE -> F("+c+".TERM);\n").getBytes());
			fos.write(("--CORRETTEZZA PARZIALE\n").getBytes());
			fos.write(("--"+c+".PRE -> G("+c+".TERM ->"+c+".POST);\n").getBytes());
			fos.write(("--CORRETTEZZA TOTALE\n").getBytes());
			fos.write(("--"+c+".PRE -> (F("+c+".TERM) & G("+c+".TERM ->"+c+".POST));\n").getBytes());
			fos.write(("--CAMMINO\n").getBytes());
			
			fos.write(("--").getBytes());
		}catch(Exception e){System.out.println(" problemi con il file "+e.getMessage()+" "+ e.getCause());}

	}
*/
	/**
	 * @param w
	 * @return
	 */
	private String editVARSection(Graph w){
		if (hash==null) {

		String result ="\nVAR\n";

		Vector<Variabile> var=w.getVariableSet();
		int size=var.size();

		for(int i=0; i<size; i++){
			Variabile v=(Variabile)var.elementAt(i);
			result +=" "+v.getName()+" :";
			if(v.isArray() && v.getTipo()=="int"){
				result +=" array"+" 0..2"+" of -10..10;\n";	
			}
			if(v.getTipo()=="int" && !v.isArray()){
				result +=" 0..3;"+"\n";

			}
		}
		Vector<ParametroFormale> vct2=w.getParameterSet();
		int size2=vct2.size();
		for(int j=0; j<size2; j++){
			ParametroFormale pf=(ParametroFormale)vct2.elementAt(j);
			result +=" "+pf.nome+" :";
			if(pf.isArray && pf.tipo=="int"){
				result +=" array"+" 0..2"+" of -10..10;\n";	
			}
			if(pf.tipo=="int" && !pf.isArray){
				result +=" 0..3;"+"\n";

			}

		}
		//aggiunto da me per inserimento della variabile cammino in modo da cercare una base di cammini
		//*********************************************************************************************
		result +=" cammino : 1.." + lunghezzaBase + ";\n\n";
		//*********************************************************************************************
		result +=" PC : 1.."+w.getLoc()+";\n\n";

		return result;
		}
		
		
		
		
		else {
			String result ="\nVAR\n";

			Vector<Variabile> var=w.getVariableSet();
			int size=var.size();

			for(int i=0; i<size; i++){
				Variabile v=(Variabile)var.elementAt(i);
				result +=" "+v.getName()+" :";
				if(v.isArray() && v.getTipo()=="int"){
					result +=" array"+" 0.."+hash.get(v.getName()+".length")[0].getText()+" of "+hash.get(v.getName())[0].getText()+".."+hash.get(v.getName())[1].getText()+";\n";	
				}
				if(v.getTipo()=="int" && !v.isArray()){
					result +=hash.get(v.getName())[0].getText()+".."+hash.get(v.getName())[1].getText()+";\n";	

				}
			}
			Vector<ParametroFormale> vct2=w.getParameterSet();
			int size2=vct2.size();
			for(int j=0; j<size2; j++){
				ParametroFormale pf=(ParametroFormale)vct2.elementAt(j);
				result +=" "+pf.nome+" :";
				if(pf.isArray && pf.tipo=="int"){
					result +=" array"+" 0.."+(Integer.parseInt(hash.get(pf.nome+".length")[0].getText())-1)+" of "+hash.get(pf.nome)[0].getText()+".."+hash.get(pf.nome)[1].getText()+";\n";	
					}
				if(pf.tipo=="int" && !pf.isArray){
					result +=hash.get(pf.nome)[0].getText()+".."+hash.get(pf.nome)[1].getText()+";\n";	
				}

			}

			result +=" PC : 1.."+w.getLoc()+";\n\n";
			//aggiunto da me per inserimento della variabile cammino in modo da cercare una base di cammini
			//*********************************************************************************************
				result +=" cammino : 1.." + lunghezzaBase + ";\n\n";
			//*********************************************************************************************
			return result;
		}

	}

	/**
	 * @param w
	 * @return
	 */
	private String editDEFINESection(Graph w){   

		String result="\nDEFINE\n";

		Vector<Integer> vct3=w.getNumTermIstr();
		int sizeRetArray = vct3.size();

		if(sizeRetArray==0){
			result+=" TERM := PC = "+w.getLoc()+ " & cammino=MAXCAMMINI;\n";
			result+=" MAXCAMMINI:=" + lunghezzaBase+";\n";
		}
		else{
			String str="";
			for(int k=0;k<sizeRetArray;k++){
				Integer istr=(Integer)vct3.elementAt(k);
				int el=istr.intValue();
				if(k==sizeRetArray-1)
					str +="PC = "+el;
				else
					str +="PC = "+el+" | "; 
			}
			result+=" TERM := "+str+" & cammino=MAXCAMMINI;\n";   //****************
			result+=" MAXCAMMINI:=" + lunghezzaBase+";\n";
		}
		
		if (w.getMethodCall()!=null) {
			if (w.getMethodCall().getPreCondition()==null) result+=" PRE := 1;\n";
			else result+=" PRE := "+w.getMethodCall().getPreCondition()+";\n";
			if (w.getMethodCall().getPostCondition()==null) result+=" POST := 1;\n";
			else result+=" POST := "+w.getMethodCall().getPostCondition()+";\n";
	
		}
		
		Vector<GraphNode> nodes=w.getNodes();
		for(int i=0;i<nodes.size();i++ ){
			GraphNode currNodo=(GraphNode)nodes.elementAt(i);
			
		if (currNodo.getMethodCall()!=null) {
			String pre = null;
			String post = null;
			
			for (int j = 0; j < currNodo.getMethodCall().getDeclaredParameters().size(); j++) {
				String dp = currNodo.getMethodCall().getDeclaredParameters().get(j);
				String pp = currNodo.getMethodCall().getPassedParameters().get(j);
				System.out.println("[[[+" + dp);
				System.out.println("[[[-" + pp);
				if (currNodo.getMethodCall().getPreCondition() != null) {
					pre = currNodo.getMethodCall().getPreCondition().replace(dp, pp);
					System.out.println("@@@" + currNodo.getMethodCall().getPreCondition() + " " + pre);
					result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := "+pre+";\n";
				}
				else {
					result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := 1;\n";
				}
				if (currNodo.getMethodCall().getPostCondition() != null) {
					post = currNodo.getMethodCall().getPostCondition().replace(dp, pp);
					System.out.println("@@@" + currNodo.getMethodCall().getPostCondition() + " " + post);
					result+=" "+currNodo.getMethodCall().getMethodName()+"POST := "+post+";\n";
					
				}
				else {
					result+=" "+currNodo.getMethodCall().getMethodName()+"POST := 1;\n";
				}
			}
			
			
		/*	System.out.println("Trovato un method call");
			System.out.println("Precondizioni: "+currNodo.getMethodCall().getPreCondition());
			System.out.println("Postcondizioni: "+currNodo.getMethodCall().getPostCondition());
			if (currNodo.getMethodCall().getPreCondition()==null) result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := 1;\n";
			else result+=" "+currNodo.getMethodCall().getMethodName()+"PRE := "+currNodo.getMethodCall().getPreCondition()+";\n";
			if (currNodo.getMethodCall().getPostCondition()==null) result+=" "+currNodo.getMethodCall().getMethodName()+"POST := 1;\n";
			else result+=" "+currNodo.getMethodCall().getMethodName()+"POST := "+currNodo.getMethodCall().getPostCondition()+";\n";
		*/
		}
		}
			
		//per definire PRE, POST, TERm
/*		if (prePost==null) {
			result+=" PRE := 1;\n";
			result+=" POST := 1;\n\n";
		}
		else {
			String pre = prePost.get("pre").getText();
			if ((pre == null) || (pre.length() <= 0))
				pre = "1";
			String post = prePost.get("post").getText();
			if ((post == null) || (post.length() <= 0))
				post = "1";
			result+=" PRE := "+pre+";\n";
			result+=" POST := "+post+";\n\n";
		}*/
		result+="\n";
		return result;
	}

	/**
	 * @param w
	 * @return
	 */
	private String editASSIGNSection(Graph w){   

		String result = "ASSIGN\n";
		Vector<ParametroFormale> vct2=w.getParameterSet();
		
		int size2=vct2.size();
/*		if (hash==null) {
		for(int k=0; k<size2; k++){

			ParametroFormale pf=(ParametroFormale)vct2.elementAt(k);
			if(pf.isArray && !sideEffect){
			for(int i=0; i<=2;i++){
					result+=" next("+pf.nome+"[" +i+ "]"+") := "+pf.nome+"[" +i+ "] ;\n";
				}
			}

		}
		}
		
		else {
			for(int k=0; k<size2; k++){

				ParametroFormale pf=(ParametroFormale)vct2.elementAt(k);
				if(pf.isArray && !sideEffect){
					for(int i=0; i<Integer.parseInt(hash.get(pf.nome+".length")[0].getText());i++){
						result+=" next("+pf.nome+"[" +i+ "]"+") := "+pf.nome+"[" +i+ "] ;\n";
					}
				}

			}	
		}*/
		
	
		return result;
	}  

	
	
	
	/*else {
		if (hash==null) {
			if(currPar.isArray){
			for(int q=0; q<=2;q++){
					result+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
				}
			}

		}
					
		else {
			if(currPar.isArray){
					for(int q=0; i<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
						result+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
					}
				}

			}	
		}*/
	
	
	/**
	 * @param w
	 * @return
	 */
	private String editTRANSSection(Graph w){

		String result="TRANS\n case\n";
		Vector<GraphNode> nodes=w.getNodes();
		Vector<Variabile> localVar = w.getVariableSet();
		Vector<ParametroFormale> formalParameters = w.getParameterSet();

		for(int i=0;i<nodes.size();i++ ){
			String riga = "";
			
			GraphNode currNodo=(GraphNode)nodes.elementAt(i);
			riga += "   PC = "+ currNodo.getInitPC()+" ";
			
					
			if (currNodo.getCondition() != null) {
				String cond = currNodo.getCondition().getImage();
				cond = cond.replace("==", "=");
				
				if ((cond != null) && (cond.length() > 0)) {
					
				

					riga+="& "+cond+ " ";
				}
			}
			
			if(i==nodes.size()-1)
				riga+="& cammino=" + lunghezzaBase + " ";
			
			riga +=": ";
			int destPC=currNodo.getDestPC();
			riga +="next(PC) = "+ destPC + " ";



			String expr= currNodo.getExpression();



			if(expr==null || expr.equals("") ){

				for(int j=0;j<localVar.size();j++){

					Variabile currVar=(Variabile)localVar.elementAt(j);
					String nomeVar=currVar.getName();
					riga += "& next("+nomeVar + ") = " +nomeVar+" "; 


				}
				
				riga+= "& next(cammino)=cammino ";
				
				for(int k=0;k<formalParameters.size();k++){

					ParametroFormale currPar=(ParametroFormale)formalParameters.elementAt(k);
					if(!currPar.isArray){
						String nomePar=currPar.nome;
						riga += "& next("+nomePar + ") = " +nomePar+" "; 
					}
					else {
						if (hash==null) {
							for(int q=0; q<=2;q++){
								riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
								}
						}
									
						else {
						for(int q=0; q<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
								riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
									}


							}	
						}

				}
			} 	
			else{

				//facciamo substring eliminando il primo carattere che e' uno spazio;
				String updateVar= currNodo.getVariable();
				//Spesso all'inizio ci sono aggiunti degli spazi in updateVar, e quindi dobbiamo verificare se ce ne sono, ed eliminarli
				int startRealString=0;
				char c=updateVar.charAt(startRealString);
				while(c==' '){
					startRealString=startRealString + 1;
					c=updateVar.charAt(startRealString);
				}  
				//eliminiamo gli spazi bianchi da updateVar 
				updateVar=updateVar.substring(startRealString);

				//	System.out.println("L'updateVar e' : "+updateVar+"\n");
				for(int j=0;j<localVar.size();j++){
					Variabile currVar=(Variabile)localVar.elementAt(j);
					String nomeVar=currVar.getName();

					//	System.out.println("Il nomeVar e': "+nomeVar+"\n");
					if(!nomeVar.equals(updateVar)){
						riga += "& next("+nomeVar + ") = " +nomeVar+" "; 
					}
					else{


						//dobbiamo considerare il primo carattere significativo(cioe' diverso da ' ')
						//e controllare se sia un '='
						int firstCharOffset=0;
						char firstChar=expr.charAt(firstCharOffset);
						boolean soloSpaziVuoti=false;
						while(firstChar==' '&& !soloSpaziVuoti){
							firstCharOffset=firstCharOffset+1;
							//NOTA:NON ELIMINARE QUESTO CONTROLLO: e' NECESSARIO POICHe' SI SONO VERIFICATI DEI CASI
							// DI ECCEZIONE DOVUTI A CASI DI STRINGHE expr costituite da soli SPAZI VUOTi ' '
							if(firstCharOffset<expr.length()){
								firstChar=expr.charAt(firstCharOffset);
							}
							else soloSpaziVuoti=true;
						}
						if(firstChar != '='){
							riga += "& next("+nomeVar + ") = " +expr+" "; 
						}
						else{
							riga += "& next("+nomeVar + ") " +expr+" ";
						}	
					}

				}

				//***************************************************
					riga+= "& next(cammino)=cammino ";
				//***************************************************
				
				for(int k=0;k<formalParameters.size();k++){
					ParametroFormale currPar=(ParametroFormale)formalParameters.elementAt(k);
					String nomePar=currPar.nome;
					System.out.println("\n\n\n\n\n\n\nupdateVar: "+updateVar);
					if(!currPar.isArray){

	
						//	System.out.println("Il nomeVar e': "+nomeVar+"\n");
						if(!nomePar.equals(updateVar)){
							riga += "& next("+nomePar + ") = " +nomePar+" "; 
						}
						else{
							//dobbiamo considerare il primo carattere significativo(cioe' diverso da ' ')
							//e controllare se sia un '='
							int firstCharOffset=0;
							char firstChar=expr.charAt(firstCharOffset);
							while(firstChar==' '){
								firstCharOffset=firstCharOffset+1;
								firstChar=expr.charAt(firstCharOffset);
							}
							if(firstChar != '='){
								riga += "& next("+nomePar + ") = " +expr+" "; 
							}
							else{
								riga += "& next("+nomePar + ") " +expr+" ";
							}	
						}
					} 
					else {
						if (hash==null) {
							for(int q=0; q<=2;q++){
								if(!(currPar.nome+"[" +q+ "]").equals(updateVar)) riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
								else riga+="& next("+currPar.nome+"[" +q+ "]"+") "+expr+" ";
								}
						}
									
						else {
						for(int q=0; q<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
							if(!(currPar.nome+"[" +q+ "]").equals(updateVar)) riga+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
							else riga+="& next("+currPar.nome+"[" +q+ "]"+") "+expr+" ";
							}


							}	
						}


				}

			}
			riga+= ";\n" ;
			riga = repairVectors(w,riga);
			riga= evaluateExpressions(riga);
			if (currNodo.getMethodCall()!=null) {
				riga=riga.replace(riga.substring(riga.indexOf(currNodo.getMethodCall().getMethodName()), (riga.indexOf(currNodo.getMethodCall().getMethodName())+riga.substring(riga.indexOf(currNodo.getMethodCall().getMethodName())).indexOf(")")+1)), currNodo.getMethodCall().getMethodName()+"POST");
				riga=riga.replace(":","& "+currNodo.getMethodCall().getMethodName()+"PRE :");
				
			}
		//	if (j>0 ) i--;
			result+=riga;
		}
		
		//*********************************************
			GraphNode currNodo=(GraphNode)nodes.elementAt(nodes.size()-1);
			result += "   PC = " + (currNodo.getInitPC()) + " & cammino!=" + lunghezzaBase + ": next(PC)=1 & next(cammino)=cammino +1 ";
			
			for(int j=0;j<localVar.size();j++){
				Variabile currVar=(Variabile)localVar.elementAt(j);
				String nomeVar=currVar.getName();

					result += "& next("+nomeVar + ") = " +nomeVar+" "; 
			}
			result+=";\n";
		//*********************************************
		
		String def="   1: next(PC)=PC ";
		for(int k=0;k<formalParameters.size();k++){

			ParametroFormale currPar=(ParametroFormale)formalParameters.elementAt(k);
			//dobbiamo stampare nella sezione TRANS solo i parametri formali di tipo intero, e non quelli di tipo array
			//che li abbiamo resi tutti statici nella sezione ASSIGN
			if(!currPar.isArray){
				String nomePar=currPar.nome;
				def += "& next("+nomePar + ") = " +nomePar+" "; 
			}
			else {
				if (hash==null) {
					for(int q=0; q<=2;q++){
							def+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
						}
				}
							
				else {
							for(int q=0; q<Integer.parseInt(hash.get(currPar.nome+".length")[0].getText());q++){
								def+="& next("+currPar.nome+"[" +q+ "]"+") = "+currPar.nome+"[" +q+ "] ";
							}
					}	
				}
		}
		
		//******************************************************
			def+= "& next(cammino)=cammino ";
		//******************************************************
		
		for(int j=0;j<localVar.size();j++){
			Variabile currVar=(Variabile)localVar.elementAt(j);
			String nomeVar=currVar.getName();

			//	System.out.println("Il nomeVar e': "+nomeVar+"\n");
				def += "& next("+nomeVar + ") = " +nomeVar+" "; 
		}

				result+=def;

		result+=";\nesac\n";
		result=checkBounds(result);
		
		

		return result;
	}
	
	
	
	
	public String repairVectors(Graph w,String riga) {

		//correttore lunghezze array
		if (riga.indexOf(".length")>-1)  {
			if (hash==null) {	
				StringTokenizer st = new StringTokenizer(riga,"!<>=|()+-*/ ");
				while (st.hasMoreTokens()) {
					String key = st.nextToken();
					if (key.indexOf(".length")>-1)  
						riga = riga.replace(key, "3");
				}
			}
			else {
				StringTokenizer st = new StringTokenizer(riga,"!<>=|()+-*/ ");
				while (st.hasMoreTokens()) {
					String key = st.nextToken();
					if (key.indexOf(".length")>-1) { 
						StringTokenizer st3 = new StringTokenizer(key,".");
						String tokenizer = st3.nextToken();
						riga = riga.replace(key, hash.get(tokenizer+".length")[0].getText());
					}
				}
			}
		}

		
		
		//raccolgo il contenuto degli indici degli array
		String riga2 = riga;
		List<String> list = new LinkedList<String>();
		while (riga2.indexOf("[")>-1) { 
			list.add(riga2.substring(riga2.indexOf("["),riga2.indexOf("]")+1));
			riga2=riga2.substring(riga2.indexOf("]")+1);
		}

		Vector<Variabile> localVar = w.getVariableSet();

		String lastVariabileScandita="";
		for (Variabile v:localVar) {
			for (int i = 0;i<list.size();i++)  {
				System.out.println("v "+v.getName()+";");
				System.out.println("Espressione in array "+i+": "+list.get(i));

				//cerco se la variabile e' presente negli indici degli array
			//	if (!v.getName().equals(lastVariabileScandita) && list.get(i).indexOf(v.getName())>-1) {
				if (list.get(i).indexOf(v.getName())>-1) {
						if (list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("+") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("-")  || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("*") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("/") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals(" ") || list.get(i).substring(list.get(i).indexOf(v.getName())-1, list.get(i).indexOf(v.getName())).equals("["))
						if (list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("+") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("-")  || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("*") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("/") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals(" ") || list.get(i).substring(list.get(i).indexOf(v.getName())+v.getName().length(), list.get(i).indexOf(v.getName())+v.getName().length()+1).equals("]")) {
							
							//variabile trovata negli indici degli array
							String originalRiga=riga;
							String originalRiga2="";
							riga="";
							if (hash==null) {
								if (!lastVariabileScandita.equals(v.getName())) {
								for (int k=0;k<=2;k++) {
									
										lastVariabileScandita=v.getName();
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									//	System.out.println("original riga 2: "+originalRiga2);
										//	riga+=repairVectors(w,originalRiga2.replace(":", "& "+v.getName()+"="+k+" :"));
										riga+=originalRiga2.replace(":", "& "+v.getName()+"="+k+" :");
									}
								}
								/*	else { //gi scandita in precedenza
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+0));
										//System.out.println("Original riga2: "+originalRiga2);
										riga+=originalRiga2;
										}*/
								else { //gi scandita in precedenza
									StringTokenizer st = new StringTokenizer(originalRiga,";");
								
									for (int k=0;k<=2 && st.hasMoreTokens();k++) {
										originalRiga2+=st.nextToken().replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									    originalRiga2+=";";
									}
									System.out.println("Original riga2: \n"+originalRiga2);
									riga+=originalRiga2+"\n";
									System.out.println("Riga: \n"+riga);
									
									}
								}
							
							
							else {  //hash diverso da null
								if (!lastVariabileScandita.equals(v.getName())) {
								for (int k=0;k<=Integer.parseInt(hash.get(v.getName())[1].getText())-1;k++) {
									
										lastVariabileScandita=v.getName();
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									//	System.out.println("original riga 2: "+originalRiga2);
										//	riga+=repairVectors(w,originalRiga2.replace(":", "& "+v.getName()+"="+k+" :"));
										riga+=originalRiga2.replace(":", "& "+v.getName()+"="+k+" :");
									}
								}
								/*	else { //gi scandita in precedenza
										originalRiga2=originalRiga.replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+0));
										//System.out.println("Original riga2: "+originalRiga2);
										riga+=originalRiga2;
										}*/
								else { //gi scandita in precedenza
									StringTokenizer st = new StringTokenizer(originalRiga,";");
								
									for (int k=0;k<Integer.parseInt(hash.get(v.getName())[1].getText()) && st.hasMoreTokens();k++) {
										originalRiga2+=st.nextToken().replace(list.get(i), list.get(i).replace(list.get(i).substring(list.get(i).indexOf(v.getName()),list.get(i).indexOf(v.getName())+v.getName().length()), ""+k));
									    originalRiga2+=";";
									}
									System.out.println("Original riga2: \n"+originalRiga2);
									riga+=originalRiga2+"\n";
									System.out.println("Riga: \n"+riga);
									
									}
								}
							
							
						}
				}
			}
	}
		
		
		return riga;
	}
	
	
	
	public String evaluateExpressions(String riga) {
		//raccolgo il contenuto degli indici degli array
		String riga2 = riga;
		List<String> list = new LinkedList<String>();
		while (riga2.indexOf("[")>-1) { 
			list.add(riga2.substring(riga2.indexOf("["),riga2.indexOf("]")+1));
			riga2=riga2.substring(riga2.indexOf("]")+1);
		}
		for (int i=0;i<list.size();i++) {
			System.out.println("Espressione: "+list.get(i));
			Expression exp = new Expression(list.get(i).substring(1, list.get(i).length()-1));
			 BigDecimal result = exp.eval();
			 System.out.println("Valutazione: "+result);
			 riga=riga.replace(list.get(i), "["+result+"]");
		}
		
		return riga;
	}
	
	
	
	
	public String checkBounds(String result) {
		StringTokenizer numRighe = new StringTokenizer(result,";");
		String riga="";
		while (numRighe.hasMoreTokens()) {
			riga=numRighe.nextToken();
			
			
			if (hash==null) {
			    if (riga.indexOf("[3]")>-1) result=result.replace(riga+";", "");
				if (riga.indexOf("[-1]")>-1) result=result.replace(riga+";", "");
			}
			
			
			else { //hash e' diverso da null
				StringTokenizer st = new StringTokenizer(riga,"!<>=|()+-*/ ");
				while (st.hasMoreTokens()) {
					String key = st.nextToken();
					if (key.indexOf("[")>-1) {  //sistemo indici vettori
						StringTokenizer st2 = new StringTokenizer(key,"[]");
						String vector = "";
						String position = "";
						if (st2.hasMoreTokens())vector = st2.nextToken();
						if (st2.hasMoreTokens())position = st2.nextToken();

						try {
							int indice = Integer.parseInt(position); //controllo se si tratta di un numero tra le parentesi quadre
							if (indice>=Integer.parseInt(hash.get(vector+".length")[0].getText())) result=result.replace(riga+";", "");
							if (riga.indexOf("[-1]")>-1) result=result.replace(riga+";", "");
						
						}
						catch (Exception ex) {  //non e' un numero
							System.out.println("Errore : eccezione in check bounds!");
						}
					}
				}
			}
		}
	
		
		return result;
	}
	
	
}
