/**
 * Jasmine
 * 31/mag/08
 */
package it.uniroma1.dis.jasmine;

import it.uniroma1.dis.jasmine.ui.utils.NumberField;

import java.util.Hashtable;
import java.util.Vector;

/**
 * Grafo di un metodo.
 */
public class Graph {
	private Vector<GraphNode> nodes;
	private Vector<Variabile> variables;
	private Vector<ParametroFormale> parameters;
	private Vector<Integer> numTermIstr;
	private String methodName;
	private MethodCall methodCall;
	private int loc;
	// hash che associa il nome di ogni variabile ai suoi valori numerici, dopo la scelta del range:
	private Hashtable<String,NumberField[]> variableHash;
	//variabile stringa che contiene il metodo (serve per la gestione di metodi multipli)
	private String metodo;
	
	/**
	 * 
	 */
	public Graph() {
		nodes = new Vector<GraphNode>();
		variables = new Vector<Variabile>();
		parameters = new Vector<ParametroFormale>();
		numTermIstr = new Vector<Integer>();
	}

	/**
	 * @return the methodName
	 */
	public String getMethodName() {
		return methodName;
	}

	/**
	 * @param methodName the methodName to set
	 */
	public void setMethodName(String methodName) {
		this.methodName = methodName;
	}
	
	public void setCodiceMetodo(String met){
		metodo=met;
	}

	public String getCodiceMetodo(String met){
		return metodo;
	}
	
	/**
	 * @return the nodes
	 */
	public Vector<GraphNode> getNodes() {
		return nodes;
	}
	
	/**
	 * @param gn
	 * @return
	 */
	public boolean addNode(GraphNode gn) {
		if (gn != null)
			return nodes.add(gn);
		else
			return false;
	}
	
    /**
     * @return
     */
    public Vector<Variabile> getVariableSet(){
    	return variables;
    }
    
    /**
     * @return
     */
    public Vector<ParametroFormale> getParameterSet(){
    	return parameters;
    }

	/**
	 * @return the loc
	 */
	public int getLoc() {
		return loc;
	}

	/**
	 * @param loc the loc to set
	 */
	public void setLoc(int loc) {
		this.loc = loc;
	}

	/**
	 * @return the variables
	 */
	public Vector<Variabile> getVariables() {
		return variables;
	}

	/**
	 * @return the parameters
	 */
	public Vector<ParametroFormale> getParameters() {
		return parameters;
	}

	/**
	 * @return the numTermIstr
	 */
	public Vector<Integer> getNumTermIstr() {
		return numTermIstr;
	}

	/**
	 * @return the methodCall
	 */
	public MethodCall getMethodCall() {
		return methodCall;
	}

	/**
	 * @param methodCall the methodCall to set
	 */
	public void setMethodCall(MethodCall methodCall) {
		this.methodCall = methodCall;
	}

	/**
	 * @return the variableHash
	 */
	public Hashtable<String, NumberField[]> getVariableHash() {
		return variableHash;
	}

	/**
	 * @param variableHash the variableHash to set
	 */
	public void setVariableHash(Hashtable<String, NumberField[]> variableHash) {
		this.variableHash = variableHash;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + loc;
		result = prime * result
				+ ((methodName == null) ? 0 : methodName.hashCode());
		result = prime * result + ((nodes == null) ? 0 : nodes.hashCode());
		result = prime * result
				+ ((numTermIstr == null) ? 0 : numTermIstr.hashCode());
		result = prime * result
				+ ((parameters == null) ? 0 : parameters.hashCode());
		result = prime * result
				+ ((variables == null) ? 0 : variables.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Graph other = (Graph) obj;
		if (loc != other.loc)
			return false;
		if (methodName == null) {
			if (other.methodName != null)
				return false;
		} else if (!methodName.equals(other.methodName))
			return false;
		if (nodes == null) {
			if (other.nodes != null)
				return false;
		} else if (!nodes.equals(other.nodes))
			return false;
		if (numTermIstr == null) {
			if (other.numTermIstr != null)
				return false;
		} else if (!numTermIstr.equals(other.numTermIstr))
			return false;
		if (parameters == null) {
			if (other.parameters != null)
				return false;
		} else if (!parameters.equals(other.parameters))
			return false;
		if (variables == null) {
			if (other.variables != null)
				return false;
		} else if (!variables.equals(other.variables))
			return false;
		return true;
	}
}
