/**
 * Jasmine
 * 29/mag/08
 */
package it.uniroma1.dis.jasmine;

import it.uniroma1.dis.jasmine.ui.utils.NumberField;

import java.io.File;
import java.util.Hashtable;

import javax.swing.JTextArea;

/**
 *
 */
public interface IJavaParser {
	/**
	 * Restituisce il grafo di flusso, come Map di nome metodo e vettore di GraphNode.
	 * @param javaFile
	 * @return
	 */
	public GraphWrapper generateGraph(File javaFile);
	
	/**
	 * Restituisce una stringa rappresentante il grafo di flusso.
	 * @param javaFile
	 * @return
	 */
	public String printGraph(File javaFile);
	
	/**
	 * Restituisce una stringa rappresentante il grafo di flusso.
	 * @param wrapper
	 * @return
	 */
	public String printGraph(GraphWrapper wrapper);
	
	/**
	 * Scrive su file il codice SMV.
	 * @param javaFile
	 * @param nodes
	 * @param hash
	 * @param prePost
	 * @param sideEffect
	 * @return
	 */
	public boolean generateSMVFile(File javaFile, int[] nodes, int optCammino, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect);
	 
	/**
	 * @param wrapper
	 * @param nodes
	 * @param optCammino
	 * @param hash
	 * @param prePost
	 * @param sideEffect
	 * @return
	 */
	public boolean generateSMVFile(GraphWrapper wrapper, int[] nodes, int optCammino, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect);
	
	/**
	 * @param wrapper
	 * @param nodes
	 * @param optCammino
	 * @param hash
	 * @param prePost
	 * @param sideEffect
	 * @param currentMethodOnly
	 * @return
	 */
	public String generateSMV(GraphWrapper wrapper, int[] nodes, int optCammino, Hashtable<String,NumberField[]> hash, Hashtable<String,JTextArea> prePost, boolean sideEffect, boolean currentMethodOnly);
}
