package it.uniroma1.dis.jasmine.ui;

import it.uniroma1.dis.jasmine.Graph;
import it.uniroma1.dis.jasmine.ui.utils.TextComponentPopup;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class PrePostDialog extends JDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JButton okButton;
	Hashtable<String,JTextArea> prePost = new Hashtable<String,JTextArea>();
	boolean confirm = false;



	public PrePostDialog(JFrame parent, Graph g) {
		super(parent, true);

		JTextArea pre = new JTextArea(4,0);
		pre.setText("1");
		JTextArea post = new JTextArea(4,0);
		post.setText("1");
		pre.setComponentPopupMenu(new TextComponentPopup(pre));
		post.setComponentPopupMenu(new TextComponentPopup(post));
		prePost.put("pre", pre);
		prePost.put("post", post);
		
		String methodDeclaration = g.getMethodName();
		if (g.getMethodCall() != null)
			methodDeclaration = g.getMethodCall().getDeclaration();
		
		final int DEFAULT_FRAME_WIDTH = 300;
		final int DEFAULT_FRAME_HEIGHT = 300;
		setSize(DEFAULT_FRAME_WIDTH, DEFAULT_FRAME_HEIGHT);


		Dimension frameSize = this.getSize();
		setMinimumSize(frameSize);
		setLocation(
				(Toolkit.getDefaultToolkit().getScreenSize().width
						- frameSize.width) / 2,
						(Toolkit.getDefaultToolkit().getScreenSize().height
								- frameSize.height) /2);


		setTitle("Seleziona eventuali pre e post condizioni");
		Container cnt = getContentPane();
		JPanel prePostPanel = new JPanel();
		prePostPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		prePostPanel.setLayout(new BoxLayout(prePostPanel, BoxLayout.Y_AXIS));
		cnt.setLayout(new GridLayout(0, 1));
		JLabel preLabel = new JLabel("PRECONDIZIONI");
		preLabel.setHorizontalAlignment(JLabel.CENTER);
		JLabel postLabel = new JLabel("POSTCONDIZIONI");
		postLabel.setHorizontalAlignment(JLabel.CENTER);
		prePostPanel.add(new JLabel("Metodo: " + methodDeclaration));
		prePostPanel.add(Box.createVerticalStrut(10));
		prePostPanel.add(preLabel);
		prePostPanel.add(new JScrollPane(prePost.get("pre")));
		prePostPanel.add(postLabel);
		prePostPanel.add(new JScrollPane(prePost.get("post")));
		cnt.add(prePostPanel);

		okButton = new JButton("OK");
		ActionListener listener = new ButtonAction();		// ACTION-LISTENER x pulsanti
		okButton.addActionListener(listener);
		prePostPanel.add(okButton);
		
	}



	public Hashtable<String,JTextArea> evaluatePrePost() {
		if (confirm) return prePost;
		else return null;
	}



	private class ButtonAction implements ActionListener	// intercetta eventi nei pulsanti
	{ public void actionPerformed(ActionEvent event)
	{ Object source = event.getSource();		// trova pulsante premuto

	if (source == okButton)	{
		confirm = true;
		dispose();
	}
	}
	}
}

