package it.uniroma1.dis.jasmine.ui;

import it.uniroma1.dis.jasmine.Graph;
import it.uniroma1.dis.jasmine.ParametroFormale;
import it.uniroma1.dis.jasmine.Variabile;
import it.uniroma1.dis.jasmine.ui.utils.NumberField;
import it.uniroma1.dis.jasmine.ui.utils.TextComponentPopup;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

public class RangeDialog extends JDialog {
	/**
	 * 
	 */
	//parte del range variabili
	private static final long serialVersionUID = 1L;
	private JButton okButton;
	Hashtable<String,NumberField[]> hash = new Hashtable<String,NumberField[]>();
	boolean confirmRange = false;
	private JTabbedPane tabPane;
	Hashtable<String,JTextArea> prePost = new Hashtable<String,JTextArea>();
	boolean confirmPrePost = false;
	
	//parte delle pre e post condizioni
	
	

	/*
	 * NumberField[0] = MIN
	 * NumberField[1] = MAX
	 * 
	 * case Array: key: nomeVar.length; NumberField[0] = LENGTH
	 */
	public RangeDialog(JFrame parent, Graph w) {
		super(parent, true);
		tabPane=new JTabbedPane();

		// TODO Auto-generated constructor stub
		Vector<Variabile> var=w.getVariableSet();
		Vector<ParametroFormale> vct2=w.getParameterSet();

		int size=var.size();

		for(int i=0; i<size; i++){
			Variabile v=(Variabile)var.elementAt(i);
			NumberField[] num = new NumberField[2];
			NumberField minRange = new NumberField("-10");
			NumberField maxRange = new NumberField("10");
			minRange.setComponentPopupMenu(new TextComponentPopup(minRange));
			maxRange.setComponentPopupMenu(new TextComponentPopup(maxRange));
			num[0]=minRange;
			num[1]=maxRange;
			hash.put(v.getName(), num);
			if (v.isArray()) {
				NumberField[] num2 = new NumberField[1];
				NumberField len = new NumberField("4");
				len.setComponentPopupMenu(new TextComponentPopup(len));
				num2[0]=len;
				hash.put(v.getName()+".length", num2);
			}
		}
		int size2=vct2.size();
		for(int j=0; j<size2; j++){
			ParametroFormale pf=(ParametroFormale)vct2.elementAt(j);
			NumberField[] num = new NumberField[2];
			NumberField minRange = new NumberField("-10");
			NumberField maxRange = new NumberField("10");
			minRange.setComponentPopupMenu(new TextComponentPopup(minRange));
			maxRange.setComponentPopupMenu(new TextComponentPopup(maxRange));
			num[0]=minRange;
			num[1]=maxRange;
			hash.put(pf.nome, num);
			if (pf.isArray) {
				NumberField[] num2 = new NumberField[1];
				NumberField len = new NumberField("4");
				len.setComponentPopupMenu(new TextComponentPopup(len));
				num2[0]=len;
				hash.put(pf.nome+".length", num2);
			}
		}

		final int DEFAULT_FRAME_WIDTH = 400;
		final int DEFAULT_FRAME_HEIGHT = 300;
		setSize(DEFAULT_FRAME_WIDTH, DEFAULT_FRAME_HEIGHT);

		Dimension frameSize = this.getSize();
		setMinimumSize(frameSize);
		setLocation(
				(Toolkit.getDefaultToolkit().getScreenSize().width
						- frameSize.width) / 2,
						(Toolkit.getDefaultToolkit().getScreenSize().height
								- frameSize.height) /2);


		setTitle("Seleziona il range delle variabili");
		Container cnt = getContentPane();
		tabPane=new JTabbedPane();
		JPanel pannello=new JPanel();
		tabPane.add("range variabili", pannello);
		cnt.add(tabPane);
		cnt=pannello;
		GridLayout grid=new GridLayout(0,3);
		grid.setHgap(20);
		grid.setVgap(50);
		cnt.setLayout(new GridLayout(0, 3));
		cnt.add(new JLabel(""));
		JLabel min = new JLabel("MIN");
		min.setHorizontalAlignment(JLabel.CENTER);
		JLabel max = new JLabel("MAX");
		max.setHorizontalAlignment(JLabel.CENTER);
		cnt.add(min);
		cnt.add(max);

		for(int i=0; i<size; i++){
			Variabile v=(Variabile)var.elementAt(i);
			JLabel label = new JLabel(v.getName());
			label.setHorizontalAlignment(JLabel.CENTER);
			cnt.add(label);
			for (int k = 0; k<hash.get(v.getName()).length;k++)
				cnt.add(hash.get(v.getName())[k]);

			if (v.isArray()) {
				JLabel label2 = new JLabel(v.getName()+".length");
				label2.setHorizontalAlignment(JLabel.CENTER);
				cnt.add(label2);
				cnt.add(new JLabel(""));
				for (int k = 0; k<hash.get(v.getName()+".length").length;k++)
					cnt.add(hash.get(v.getName()+".length")[k]);

			}}

		for(int j=0; j<size2; j++){
			ParametroFormale pf=(ParametroFormale)vct2.elementAt(j);
			JLabel label3 = new JLabel(pf.nome);
			label3.setHorizontalAlignment(JLabel.CENTER);
			cnt.add(label3);
			for (int k = 0; k<hash.get(pf.nome).length;k++)
				cnt.add(hash.get(pf.nome)[k]);

			if (pf.isArray) {
				JLabel label4 = new JLabel(pf.nome+".length");
				label4.setHorizontalAlignment(JLabel.CENTER);
				cnt.add(label4);
				cnt.add(new JLabel(""));
				for (int k = 0; k<hash.get(pf.nome+".length").length;k++)
					cnt.add(hash.get(pf.nome+".length")[k]);

			}



		}

		cnt.add(new JLabel(""));
		cnt.add(new JLabel(""));
		cnt.add(new JLabel(""));
		cnt.add(new JLabel(""));
		okButton = new JButton("OK");
		okButton.setSize(new Dimension(50,30));
		ActionListener listener = new ButtonAction();		// ACTION-LISTENER x pulsanti
		okButton.addActionListener(listener);
		JPanel sud=new JPanel();
		sud.setLayout(new FlowLayout());
		sud.add(okButton);
		cnt.add(new JLabel(""));
		getContentPane().add(sud,BorderLayout.SOUTH);
		
		//parte del PrePost dialog
		
		JPanel pannello2=new JPanel();
		tabPane.add("PrePost condizioni", pannello2);
		cnt=pannello2;
		
		JTextArea pre = new JTextArea(4,0);
		pre.setText("1");
		JTextArea post = new JTextArea(4,0);
		post.setText("1");
		pre.setComponentPopupMenu(new TextComponentPopup(pre));
		post.setComponentPopupMenu(new TextComponentPopup(post));
		prePost.put("pre", pre);
		prePost.put("post", post);
		
		String methodDeclaration = w.getMethodName();
		if (w.getMethodCall() != null)
			methodDeclaration = w.getMethodCall().getDeclaration();
		

		JPanel prePostPanel = new JPanel();
		prePostPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		prePostPanel.setLayout(new BoxLayout(prePostPanel, BoxLayout.Y_AXIS));
		cnt.setLayout(new GridLayout(0, 1));
		JLabel preLabel = new JLabel("PRECONDIZIONI");
		preLabel.setHorizontalAlignment(JLabel.CENTER);
		JLabel postLabel = new JLabel("POSTCONDIZIONI");
		postLabel.setHorizontalAlignment(JLabel.CENTER);
		prePostPanel.add(new JLabel("Metodo: " + methodDeclaration));
		prePostPanel.add(Box.createVerticalStrut(10));
		prePostPanel.add(preLabel);
		prePostPanel.add(new JScrollPane(prePost.get("pre")));
		prePostPanel.add(postLabel);
		prePostPanel.add(new JScrollPane(prePost.get("post")));
		cnt.add(prePostPanel);

		//okButton = new JButton("OK");
		//okButton.addActionListener(listener);
		//prePostPanel.add(okButton);

	}



	public Hashtable<String,NumberField[]> evaluateRange() {
		if (confirmRange) return hash;
		else return null;
	}
	
	public Hashtable<String,JTextArea> evaluatePrePost() {
		if (confirmPrePost) return prePost;
		else return null;
	}


	/**
	 * @param h
	 * @return
	 */
	public static synchronized Hashtable<String,NumberField[]> cloneHashtable(Hashtable<String,NumberField[]> h) {
		if (h == null)
			return null;
		
		Hashtable<String,NumberField[]> c = new Hashtable<String,NumberField[]>();
		
		for (String key : h.keySet()) {
			NumberField[] newArr = new NumberField[h.get(key).length];
			
			NumberField field;
			for (int i = 0; i < h.get(key).length; i++) {
				field = h.get(key)[i];
				newArr[i] = new NumberField(new String(field.getText()));
			}
			
			c.put(new String(key), newArr);
		}
		
		return c;
	}


	private class ButtonAction implements ActionListener	// intercetta eventi nei pulsanti
	{ public void actionPerformed(ActionEvent event)
	{ Object source = event.getSource();		// trova pulsante premuto

	if (source == okButton)	{
		confirmRange = true;
		confirmPrePost=true;
		dispose();
	}
	}
	}


}

