package it.uniroma1.dis.jasmine.ui;

import it.uniroma1.dis.jasmine.ui.utils.NuSMVVariableData;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

/**
 *
 */
public class TestCaseDialogBase extends JDialog implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6094541753875028751L;
	
	private static final String[] COLUMN_NAMES = {"Variabile", "Valore"};
	
	private JButton generaTestButton;
	private NuSMVFrame nusmvFrame;
	private JButton okButton;
	protected JPanel lower;
	protected JPanel center;
	
	/**
	 * @param parent
	 * @param testCase
	 */
	public TestCaseDialogBase(JFrame parent, Vector<NuSMVVariableData> testCase) {
		super(parent, true);
		this.setResizable(true);
		this.setTitle("Ricerca della base");
		nusmvFrame=(NuSMVFrame)parent;
		
		okButton = new JButton("Ok");
		okButton.addActionListener(this);
		
		center = new JPanel();
		JTable table = buildTable(testCase);
		center.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "E' stato trovata una nuova base in " + ((nusmvFrame.stopTime-nusmvFrame.startTime)/1000) + "sec"));
		center.setLayout(new BorderLayout());
		center.add(table.getTableHeader(), BorderLayout.PAGE_START);
		center.add(new JScrollPane(table), BorderLayout.CENTER);
		
		lower= new JPanel();
		lower.add(okButton);
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(center, BorderLayout.CENTER);
		getContentPane().add(lower, BorderLayout.SOUTH);
		
		final int MIN_FRAME_WIDTH = 300;
		final int MIN_FRAME_HEIGHT = 200;
		Dimension minDim = new Dimension(MIN_FRAME_WIDTH, MIN_FRAME_HEIGHT);
		setMinimumSize(minDim);
		setPreferredSize(minDim);
		
		pack();
		setLocation((Toolkit.getDefaultToolkit().getScreenSize().width - getSize().width) / 2,
					(Toolkit.getDefaultToolkit().getScreenSize().height - getSize().height) /2);
		nusmvFrame.getJasmineFrame().graficaBase(testCase);
		parent.dispose();
	}
	
	private JTable buildTable(Vector<NuSMVVariableData> testCase) {
		Object[][] data = null;
		
		if (testCase != null) {
			data = new Object[testCase.size()][2];
			
			for (int i = 0; i < testCase.size(); i++) {
				data[i][0] = testCase.elementAt(i).getVarName();
				data[i][1] = testCase.elementAt(i).getVarValue();
			}
		}
		
		return new JTable(data, COLUMN_NAMES);
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource() == okButton) {
			dispose();
		}
	}
	

}
